# explainaboard-api-client
Backend APIs for ExplainaBoard

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.4.3
- Package version: 0.4.3
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import explainaboard_api_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import explainaboard_api_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import explainaboard_api_client
from pprint import pprint
from explainaboard_api_client.api import default_api
from explainaboard_api_client.model.api_error import APIError
from explainaboard_api_client.model.analysis_case import AnalysisCase
from explainaboard_api_client.model.benchmark import Benchmark
from explainaboard_api_client.model.benchmark_config import BenchmarkConfig
from explainaboard_api_client.model.benchmark_create_props import BenchmarkCreateProps
from explainaboard_api_client.model.benchmark_update_props import BenchmarkUpdateProps
from explainaboard_api_client.model.datasets_return import DatasetsReturn
from explainaboard_api_client.model.inline_object import InlineObject
from explainaboard_api_client.model.inline_response200 import InlineResponse200
from explainaboard_api_client.model.language_code import LanguageCode
from explainaboard_api_client.model.system import System
from explainaboard_api_client.model.system_analyses_return import SystemAnalysesReturn
from explainaboard_api_client.model.system_create_props import SystemCreateProps
from explainaboard_api_client.model.system_output import SystemOutput
from explainaboard_api_client.model.system_update_props import SystemUpdateProps
from explainaboard_api_client.model.systems_return import SystemsReturn
from explainaboard_api_client.model.task_category import TaskCategory
from explainaboard_api_client.model.user import User
# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = explainaboard_api_client.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: ApiKeyAuth
configuration = explainaboard_api_client.Configuration(
    username = 'YOUR_USERNAME',
    password = 'YOUR_PASSWORD'
)

# Configure Bearer authorization: BearerAuth
configuration = explainaboard_api_client.Configuration(
    access_token = 'YOUR_BEARER_TOKEN'
)


# Enter a context with an instance of the API client
with explainaboard_api_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = default_api.DefaultApi(api_client)
    benchmark_id = "globalbench" # str |  (optional)
parent_id = "globalbench" # str |  (optional)
featured = True # bool |  (optional)

    try:
        # Returns all benchmark configs matching the specification
        api_response = api_instance.benchmark_configs_get(benchmark_id=benchmark_id, parent_id=parent_id, featured=featured)
        pprint(api_response)
    except explainaboard_api_client.ApiException as e:
        print("Exception when calling DefaultApi->benchmark_configs_get: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**benchmark_configs_get**](docs/DefaultApi.md#benchmark_configs_get) | **GET** /api/benchmarkconfigs | Returns all benchmark configs matching the specification
*DefaultApi* | [**benchmark_delete_by_id**](docs/DefaultApi.md#benchmark_delete_by_id) | **DELETE** /api/benchmark/{benchmark_id} | Deletes a benchmark by id
*DefaultApi* | [**benchmark_get_by_id**](docs/DefaultApi.md#benchmark_get_by_id) | **GET** /api/benchmark/{benchmark_id} | Returns benchmark metadata by id
*DefaultApi* | [**benchmark_post**](docs/DefaultApi.md#benchmark_post) | **POST** /api/benchmark | Uploads a benchmark
*DefaultApi* | [**benchmark_update_by_id**](docs/DefaultApi.md#benchmark_update_by_id) | **PATCH** /api/benchmark/{benchmark_id} | Updates a benchmark by id
*DefaultApi* | [**datasets_get**](docs/DefaultApi.md#datasets_get) | **GET** /api/datasets | Returns a list of datasets
*DefaultApi* | [**healthz_get**](docs/DefaultApi.md#healthz_get) | **GET** /api/healthz | Health check
*DefaultApi* | [**info_get**](docs/DefaultApi.md#info_get) | **GET** /api/info | information for environment identifier, backend version, login URL, etc. (not intent for public users) 
*DefaultApi* | [**language_codes_get**](docs/DefaultApi.md#language_codes_get) | **GET** /api/languagecodes | Return all language codes
*DefaultApi* | [**metric_descriptions_get**](docs/DefaultApi.md#metric_descriptions_get) | **GET** /api/metric-descriptions | Return all metric descriptions
*DefaultApi* | [**system_cases_get_by_id**](docs/DefaultApi.md#system_cases_get_by_id) | **GET** /api/systems/{system_id}/cases | Returns a list of analysis cases of a particular system.
*DefaultApi* | [**system_outputs_get_by_id**](docs/DefaultApi.md#system_outputs_get_by_id) | **GET** /api/systems/{system_id}/outputs | Returns a list of outputs of a particular system.
*DefaultApi* | [**systems_analyses_post**](docs/DefaultApi.md#systems_analyses_post) | **POST** /api/systems/analyses | Returns analysis result(s) of one or multiple systems
*DefaultApi* | [**systems_delete_by_id**](docs/DefaultApi.md#systems_delete_by_id) | **DELETE** /api/systems/{system_id} | Deletes a system by id
*DefaultApi* | [**systems_get**](docs/DefaultApi.md#systems_get) | **GET** /api/systems | Returns a list of systems
*DefaultApi* | [**systems_get_by_id**](docs/DefaultApi.md#systems_get_by_id) | **GET** /api/systems/{system_id} | Returns system metadata info by id
*DefaultApi* | [**systems_post**](docs/DefaultApi.md#systems_post) | **POST** /api/systems | Submits a system
*DefaultApi* | [**systems_update_by_id**](docs/DefaultApi.md#systems_update_by_id) | **PATCH** /api/systems/{system_id} | Updates a system by id
*DefaultApi* | [**tasks_get**](docs/DefaultApi.md#tasks_get) | **GET** /api/tasks | Returns all task categories and tasks
*DefaultApi* | [**user_get**](docs/DefaultApi.md#user_get) | **GET** /api/user | get user info


## Documentation For Models

 - [APIError](docs/APIError.md)
 - [Analysis](docs/Analysis.md)
 - [AnalysisCase](docs/AnalysisCase.md)
 - [AnalysisLevel](docs/AnalysisLevel.md)
 - [AnalysisResult](docs/AnalysisResult.md)
 - [AnyType](docs/AnyType.md)
 - [ApiSystemsAnalysesFeatureToBucketInfo](docs/ApiSystemsAnalysesFeatureToBucketInfo.md)
 - [Benchmark](docs/Benchmark.md)
 - [BenchmarkConfig](docs/BenchmarkConfig.md)
 - [BenchmarkConfigAllOf](docs/BenchmarkConfigAllOf.md)
 - [BenchmarkCreateProps](docs/BenchmarkCreateProps.md)
 - [BenchmarkDatasetConfig](docs/BenchmarkDatasetConfig.md)
 - [BenchmarkMetric](docs/BenchmarkMetric.md)
 - [BenchmarkOperationConfig](docs/BenchmarkOperationConfig.md)
 - [BenchmarkTableData](docs/BenchmarkTableData.md)
 - [BenchmarkUpdateProps](docs/BenchmarkUpdateProps.md)
 - [BenchmarkViewConfig](docs/BenchmarkViewConfig.md)
 - [ClassLabel](docs/ClassLabel.md)
 - [ComboCount](docs/ComboCount.md)
 - [ConfidenceInterval](docs/ConfidenceInterval.md)
 - [DatasetFeature](docs/DatasetFeature.md)
 - [DatasetMetadata](docs/DatasetMetadata.md)
 - [DatasetsReturn](docs/DatasetsReturn.md)
 - [FeatureType](docs/FeatureType.md)
 - [InlineObject](docs/InlineObject.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [LanguageCode](docs/LanguageCode.md)
 - [MetricResult](docs/MetricResult.md)
 - [MetricResultValues](docs/MetricResultValues.md)
 - [Paper](docs/Paper.md)
 - [Score](docs/Score.md)
 - [SignificanceTestInfo](docs/SignificanceTestInfo.md)
 - [SingleAnalysis](docs/SingleAnalysis.md)
 - [System](docs/System.md)
 - [SystemAllOf](docs/SystemAllOf.md)
 - [SystemAllOfDataset](docs/SystemAllOfDataset.md)
 - [SystemAnalysesReturn](docs/SystemAnalysesReturn.md)
 - [SystemCreateProps](docs/SystemCreateProps.md)
 - [SystemInfo](docs/SystemInfo.md)
 - [SystemInfoResults](docs/SystemInfoResults.md)
 - [SystemMetadata](docs/SystemMetadata.md)
 - [SystemMetadataUpdatable](docs/SystemMetadataUpdatable.md)
 - [SystemOutput](docs/SystemOutput.md)
 - [SystemOutputProps](docs/SystemOutputProps.md)
 - [SystemUpdateProps](docs/SystemUpdateProps.md)
 - [SystemsReturn](docs/SystemsReturn.md)
 - [Task](docs/Task.md)
 - [TaskCategory](docs/TaskCategory.md)
 - [TaskMetadata](docs/TaskMetadata.md)
 - [TaskSupportedFormats](docs/TaskSupportedFormats.md)
 - [Time](docs/Time.md)
 - [Tokenizer](docs/Tokenizer.md)
 - [User](docs/User.md)
 - [Value](docs/Value.md)


## Documentation For Authorization


## ApiKeyAuth

- **Type**: HTTP basic authentication


## BearerAuth

- **Type**: Bearer authentication


## Author




## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in explainaboard_api_client.apis and explainaboard_api_client.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from explainaboard_api_client.api.default_api import DefaultApi`
- `from explainaboard_api_client.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import explainaboard_api_client
from explainaboard_api_client.apis import *
from explainaboard_api_client.models import *
```

